    001    /* ===========================================================
    002     * JFreeChart : a free chart library for the Java(tm) platform
    003     * ===========================================================
    004     *
    005     * (C) Copyright 2000-2005, by Object Refinery Limited and Contributors.
    006     *
    007     * Project Info:  http://www.jfree.org/jfreechart/index.html
    008     *
    009     * This library is free software; you can redistribute it and/or modify it
    010     * under the terms of the GNU Lesser General Public License as published by
    011     * the Free Software Foundation; either version 2.1 of the License, or
    012     * (at your option) any later version.
    013     *
    014     * This library is distributed in the hope that it will be useful, but
    015     * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
    016     * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
    017     * License for more details.
    018     *
    019     * You should have received a copy of the GNU Lesser General Public
    020     * License along with this library; if not, write to the Free Software
    021     * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301,
    022     * USA.
    023     *
    024     * [Java is a trademark or registered trademark of Sun Microsystems, Inc.
    025     * in the United States and other countries.]
    026     *
    027     * --------------------------
    028     * SunJPEGEncoderAdapter.java
    029     * --------------------------
    030     * (C) Copyright 2004, 2005, by Richard Atkinson and Contributors.
    031     *
    032     * Original Author:  Richard Atkinson;
    033     * Contributor(s):   David Gilbert (for Object Refinery Limited);
    034     *
    035     * $Id: SunJPEGEncoderAdapter.java,v 1.3.2.2 2005/11/01 16:37:01 mungady Exp $
    036     *
    037     * Changes
    038     * -------
    039     * 01-Aug-2004 : Initial version (RA);
    040     * 01-Nov-2005 : To remove the dependency on non-supported APIs, use ImageIO
    041     *               instead of com.sun.image.codec.jpeg.JPEGImageEncoder - this
    042     *               adapter will only be available on JDK 1.4 or later (DG);
    043     *
    044     */
    045
    046    package org.jfree.chart.encoders;
    047
    048    import java.awt.image.BufferedImage;
    049    import java.io.ByteArrayOutputStream;
    050    import java.io.IOException;
    051    import java.io.OutputStream;
    052
    053    import javax.imageio.ImageIO;
    054
    055    /**
    056     * Adapter class for the Sun JPEG Encoder.  The ImageEncoderFactory will only
    057     * return a reference to this class by default if the library has been compiled
    058     * under a JDK 1.4+ and is being run using a JDK 1.4+.
    059     *
    060     * @author Richard Atkinson
    061     */
    062    public class SunJPEGEncoderAdapter implements ImageEncoder {
    063
    064        private float quality = 0.75f;
    065
    066        /**
    067         * Default constructor.
    068         */
    069        public SunJPEGEncoderAdapter() {
    070        }
    071
    072        /**
    073         * Get the quality of the image encoding.
    074         *
    075         * @return A float representing the quality.
    076         */
    077        public float getQuality() {
    078            return this.quality;
    079        }
    080
    081        /**
    082         * Set the quality of the image encoding (ignored).
    083         *
    084         * @param quality  A float representing the quality.
    085         */
    086        public void setQuality(float quality) {
    087            this.quality = quality;
    088        }
    089
    090        /**
    091         * Get whether the encoder encodes alpha transparency (always false).
    092         *
    093         * @return Whether the encoder is encoding alpha transparency.
    094         */
    095        public boolean isEncodingAlpha() {
    096            return false;
    097        }
    098
    099        /**
    100         * Set whether the encoder should encode alpha transparency (not supported
    101         * for JPEG).
    102         *
    103         * @param encodingAlpha  Whether the encoder should encode alpha
    104         *                       transparency.
    105         */
    106        public void setEncodingAlpha(boolean encodingAlpha) {
    107            //  No op
    108        }
    109
    110        /**
    111         * Encodes an image in JPEG format.
    112         *
    113         * @param bufferedImage  The image to be encoded.
    114         *
    115         * @return The byte[] that is the encoded image.
    116         *
    117         * @throws IOException
    118         */
    119        public byte[] encode(BufferedImage bufferedImage) throws IOException {
    120            ByteArrayOutputStream outputStream = new ByteArrayOutputStream();
    121            encode(bufferedImage, outputStream);
    122            return outputStream.toByteArray();
    123        }
    124
    125        /**
    126         * Encodes an image in JPEG format and writes it to an OutputStream.
    127         *
    128         * @param bufferedImage  The image to be encoded.
    129         * @param outputStream  The OutputStream to write the encoded image to.
    130         * @throws IOException
    131         */
    132        public void encode(BufferedImage bufferedImage, OutputStream outputStream)
    133            throws IOException {
    134            if (bufferedImage == null) {
    135                throw new IllegalArgumentException("Null 'image' argument.");
    136            }
    137            if (outputStream == null) {
    138                throw new IllegalArgumentException("Null 'outputStream' argument.");
    139            }
    140            ImageIO.write(bufferedImage, ImageFormat.JPEG, outputStream);
    141        }
    142
    143    }